--- old/usr/src/lib/libc/port/locale/mblen.c	Fri Jul 11 11:42:59 2014
+++ new/usr/src/lib/libc/port/locale/mblen.c	Fri Jul 11 11:42:59 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2014 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins.
  * All rights reserved.
@@ -28,22 +29,29 @@
 #include "lint.h"
 #include <stdlib.h>
 #include <wchar.h>
+#include <locale.h>
+#include <xlocale.h>
 #include "mblocal.h"
+#include "localeimpl.h"
 
 int
-mblen(const char *s, size_t n)
+mblen_l(const char *s, size_t n, locale_t loc)
 {
-	static const mbstate_t initial = { 0 };
-	static mbstate_t mbs;
+	mbstate_t mbs = { 0 };
 	size_t rval;
 
 	if (s == NULL) {
 		/* No support for state dependent encodings. */
-		mbs = initial;
 		return (0);
 	}
-	rval = __mbrtowc(NULL, s, n, &mbs);
+	rval = mbrtowc_l(NULL, s, n, &mbs, loc);
 	if (rval == (size_t)-1 || rval == (size_t)-2)
 		return (-1);
 	return ((int)rval);
+}
+
+int
+mblen(const char *s, size_t n)
+{
+	return (mblen_l(s, n, uselocale(NULL)));
 }
